//   Per evolucionar a partir de zero
//   evolucio = 1    i  en el fitxer CHROME.CPP
//			#define grafica 1/0  segons si es vol la grfica o no
//       #define mesh   0
//       #define toro   0
//       #define btfd   0
//       #define btfnd  0
//       #define ccc    0
//
//   Per introduir la expressio trobada
//   evolucio = 0     i en el fitxer CHROME:CPP
//			#define grafica 1/0 segons es vulgui trobar la grfica
//       #define mesh   0                                  o no
//       #define toro   0
//       #define btfd   0
//       #define btfnd  0
//       #define ccc    1

//  cap a lanterior 2 <-   cap al posterior -> 3     aresta <<1>>

// funciona amb T 150 InitExpr 10  MaxExpr 70
//***************************************************************************
//  PFCcccm3  trevalla sobre un graf cube-conected-cycles amb d= ALPHA1
//  la evoluci de la transmisi es troba en el fitxer EVOL.TXT
//  la grfica de les fitness i la expressi final a GRAFICA.TXT
//  la expressi final tamb es guarda al fitxer RESULT:TXT
//***************************************************************************
#include "pch.h"
#include "chrome.h"
#include "primitiv.h"

extern char scratch[100];
#ifdef FASTEVAL
	extern evalnode* IpGlobal;
	extern Chrome* ChromeGlobal;
#endif


//**************************************************************************
// Define your Problem class

class GrilProb : public Problem {
public:
	GrilProb(ChromeParams* p);               // initialize functions, parameters, and data
	float fitness(Chrome* chrome);  // Driving ingredient - GP fitness function
};


//**************************************************************************
// static variables that make up the evaluation environment
// Build your environment here as statics
// where the evaluation functions can get to the data
		 
#define W 7             // nombre de pases
#define T 150 			   // increment positiu de la fitness
#define TPB 1000        // tamany total de poblaci
#define ORDRE 24        // nombre de nodes
#define ALPHA1 3        // es la d ->BFd
#define ALPHA2 2        // perque s en binari
#define LONGMOT 4       // nombre de camps utilitzats per anomenar cada node
#define GRAU 3          // dona el nombre de veins
#define Horizontal ORDRE/ALPHA1 // n de nodes per cada fila
#define Vertical ALPHA1         // n de nodes per columna

int test[ORDRE];  // prohibeix al node tornar a transmetre informacio en un mateix pas
int Orden[ORDRE]; // pas de la seqncia de lalgoritme
int Paso[ORDRE];  // etapa de pas de linformaci
int Mesh[ORDRE];  // paquets transmesos pel node
int Proc[ORDRE];  // procedncia del paquet rebut
int position[ORDRE];
long double Vec_fitness[400]; // guarda les fitness per fer la grfica
long double Vec_mitja[400];   // guarda la mitja de les fitness de la poblacio total
unsigned char graf[21][400];  // es l`espai on es pinta la grfica
unsigned char M_evol[ALPHA1][ORDRE/ALPHA1]; // espai on es pinta la evolucio
int M_evol2[ALPHA1][ORDRE/ALPHA1];
int pas,ord,b1,n,h1,a1,a5,sup,move1,move2;
int expressio=0;              // habilita levaluacio del tamany de lexpressio
int h=0;                      // comptador del tamany de lexpressio
int evolucio=0;               // Ccc=0 evolucio=1 evoluciona de zero

//**************************************************************************
// Estructures

typedef struct vertex {     // estructura per definir els nodes
	 char name[LONGMOT];     // camp pel nom
	 int vei[GRAU];        // camp per identificar els veins
	 };
	 
vertex vert[ORDRE];         // es defineix un vector de vrtex (nodes)
int numnode[ALPHA1][ALPHA2][ALPHA2][ALPHA2]; // guarda el node segons la seva
															// identificaci

//**************************************************************************
// Data handling functions

void make_nodes()           // construeix els nodes amb una forma a,x,y,z
{                           //                       per  exemple 0.1 0 1
	int i0,i1,i2,i3,i,n;     
	n=0;
	for (i0=0;i0<ALPHA1;i0++)
	  for (i1=0;i1<ALPHA2;i1++)
		 for (i2=0;i2<ALPHA2;i2++)
			for (i3=0;i3<ALPHA2;i3++)
			{
			  vert[n].name[0]=i0;
			  vert[n].name[1]=i3;
			  vert[n].name[2]=i2;
			  vert[n].name[3]=i1;
			  numnode[i0][i3][i2][i1]=n;
			  n++;
			}
}

void make_arcs()
{
	int x[LONGMOT],n,i;
	for (n=0;n<ORDRE;n++)
	{
	  for (i=0;i<LONGMOT;i++) x[i]=vert[n].name[i];
	  vert[n].vei[0]=numnode[(x[0]+1)%ALPHA1][x[1]][x[2]][x[3]]; // vei posterior
	  vert[n].vei[1]=numnode[(x[0]+ALPHA1-1)%ALPHA1][x[1]][x[2]][x[3]]; // vei anterior
	  if (x[0]==0) x[1]= (x[1]+1)%ALPHA2;
	  if (x[0]==1) x[2]= (x[2]+1)%ALPHA2;    // realitzaci dels complementaris
	  if (x[0]==2) x[3]= (x[3]+1)%ALPHA2;
	  vert[n].vei[2]=numnode[x[0]][x[1]][x[2]][x[3]]; // vei per la aresta
	} 
}	 
					  
int Posicio(long double *ma)        // introdueix els valors de la fitness dintre del rang de la grfica
{
	int posicio;
	posicio=(*ma*21)/((ORDRE-1)*T);
	return posicio;
}
retval ProcPosterior()   // evalua la procedencia del paquet rebut
{ 
	retval rval=0;                       // si es un '2' indica procedncia
	rval= (Proc[n] == 2) ;    //  dun node major a aquest
	return rval;
}

retval ProcArista()   // evalua la procedencia del paquet rebut
{ 
	retval rval=0;                       // si s un '1'  indica procedncia
	rval= (Proc[n] == 1);    //  vertex duna aresta
	return rval;
}

retval ProcAnterior()   // evalua la procedencia del paquet rebut
{ 
	retval rval=0;                       // si s un  '3' indica procedncia
	rval= (Proc[n] == 3);    // dun node menor
	return rval;
}
	
void Resetest()          // posa a zero la matriu 'test' per poder realitzar
{                       // un altre pas
	int i;
	for (i=0;i<ORDRE;i++) test[i]=0;
}							
void MoveAnt()
{
	Mesh[n]++;			      // incrementa el comptador de transmisions del node n
	Proc[h1]=2;       // marca la procedncia en el node que rep la info
	Paso[h1]=pas;
	test[n]=1;             // prohibeix al node n tornar a transmetre en aquest pas
	position[ord]=h1;
	Orden[h1]=ord;ord++;   // guarda lordre en que ha rebut la informaci
}				 

void MovePost()
{
	Mesh[n]++;
	Proc[h1]=3;
	Paso[h1]=pas;
	test[n]=1;
	position[ord]=h1;
	Orden[h1]=ord;ord++;
}				 

void MoveArist()
{
	Mesh[n]++;
	Proc[h1]=1;
	Paso[h1]=pas;
	test[n]=1;
	position[ord]=h1;
	Orden[h1]=ord;ord++;
}				 

//**************************************************************************
//////////////////////////  Problem specific functions

// Use the OPDEF,EVAL,IP and CURCHROME defines
// and the code will recompile for different eval methods
	  
OPDEF(IfProc_OriEval)     // mira si al procedencia s lorigen
{                         // permet quatre moviments
			retval rval=0;
			move1=0;move2=0;       
			if (expressio==1) h++;  // comptador del tamany de lxpressi
			if ((n==0) || (expressio==1))
			{
			  Proc[0]=5;
			  move1=1;  // condici que obliga a mirar la procedencia abans de moures
			  rval=EVAL;
			}
			else {  
			  IP++;
			  TRAVERSE();    // Jump the first expression
			  IP--;   		  // Back up for EVAL
			}	
			return rval;
}

	class IfProc_Ori : public Function {
	public:
	IfProc_Ori() {strcpy(name,"IFPROC_ORI");argnum=1;varnum=0;weight=100;
	evalfunc=IfProc_OriEval;};
	};

OPDEF(IfProc_AnteriorEval)
{    
			retval rval=0;
			move1=0;move2=0;
			if (expressio==1) h++;
			if ((ProcAnterior()) || (expressio==1))
			{
			  move1=1;
			  rval=EVAL;				  
			}
			else {  
			  IP++;
			  TRAVERSE();
			  IP--;																		// Back up for EVAL				  
			}
			return rval;
}

	class IfProc_Anterior : public Function {
	public:
	IfProc_Anterior() {strcpy(name,"IFPROC_ANTERIOR");argnum=1;varnum=0;weight=100;
	evalfunc=IfProc_AnteriorEval;};
	};
						
 OPDEF(IfProc_PosteriorEval)
{    
			retval rval=0;
			move1=0;move2=0;
			if (expressio==1) h++;
			if ((ProcPosterior()) || (expressio==1))
			{
			  move1=1;
			  rval=EVAL;				  
			}
			else {  
			  IP++;
			  TRAVERSE();
			  IP--;																		// Back up for EVAL				  
			}
			return rval;
}

	class IfProc_Posterior : public Function {
	public:
	IfProc_Posterior() {strcpy(name,"IFPROC_Posterior");argnum=1;varnum=0;weight=100;
	evalfunc=IfProc_PosteriorEval;};
	};
						
OPDEF(IfProc_AristaEval)
{    
			retval rval=0;
			move1=0;move2=0;
			if (expressio==1) h++;
			if ((ProcArista()) || (expressio==1))
			{
			  move1=1;
			  rval=EVAL;				  
			}
			else {  
			  IP++;
			  TRAVERSE();
			  IP--;																		// Back up for EVAL				  
			}
			return rval;
}

	class IfProc_Arista : public Function {
	public:
	IfProc_Arista() {strcpy(name,"IFPROC_ARISTA");argnum=1;varnum=0;weight=100;
	evalfunc=IfProc_AristaEval;};
	};
			
OPDEF(If_torn_0Eval)
{ 
			retval rval=0;
			move2=0;
			if (expressio==1) h++;
			if ((move1==1) || (expressio==1))
			{   
			  if ((Mesh[n]==0) || (expressio==1))
			  {  
				 move2=1;
				 rval=EVAL;
			  }
			  else {  
				 IP++;
				 TRAVERSE();
				 IP--;			  	
			  }
			}
			else rval=-1;	 		 
			return rval;
}

	class If_torn_0 : public Function {
	public:
	If_torn_0() {strcpy(name,"IF_TORN_0");argnum=1;varnum=0;weight=100;
	evalfunc=If_torn_0Eval;};
	};

OPDEF(If_torn_1Eval)
{ 
			retval rval=0;
			move2=0;
			if (expressio==1) h++;
			if ((move1==1) || (expressio==1))
			{   
			  if ((Mesh[n]==1) || (expressio==1))
			  {  
				 move2=1;
				 rval=EVAL;
			  }
			  else {  
				 IP++;
				 TRAVERSE();
				 IP--;			  	
			  }
			}
			else rval=-1;	 		 
			return rval;
}

	class If_torn_1 : public Function {
	public:
	If_torn_1() {strcpy(name,"IF_TORN_1");argnum=1;varnum=0;weight=100;
	evalfunc=If_torn_1Eval;};
	};

OPDEF(If_torn_2Eval)
{ 
			retval rval=0;
			move2=0;
			if (expressio==1) h++;
			if ((move1==1) || (expressio==1))
			{   
			  if ((Mesh[n]==2) || (expressio==1))
			  {  
				 move2=1;
				 rval=EVAL;
			  }
			  else {  
			  IP++;
			  TRAVERSE();
			  IP--;			  	
			  }
			}
			else rval=-1;	 		 
			return rval;
}

	class If_torn_2 : public Function {
	public:
	If_torn_2() {strcpy(name,"IF_TORN_2");argnum=1;varnum=0;weight=100;
	evalfunc=If_torn_2Eval;};
	};
	
OPDEF(MovePosterior)
{
			retval rval=0;
			h++;
			if (expressio==0) 
			{ 
			  if (move2==1) 
			  {
				 move2=0;
				 if (test[n]==0) 
				 {
					h1=vert[n].vei[0];
					if  (Proc[h1]==0)
					{
					  MovePost();
					  rval=T;
					}
				 } 
			  }		
			  else rval=-1;
			}
			else h++; 
			return rval;
}	 	

OPDEF(MoveAnterior)
{
			retval rval=0;
			h++;
			if (expressio==0) 
			{ 
			  if (move2==1)
			  {
				 move2=0;
				 if (test[n]==0) 
				 {
					h1=vert[n].vei[1];
					if  (Proc[h1]==0)
					{
					  MoveAnt();
					  rval=T;
					}
				 } 
			  }		
			  else rval=-1;
			}
			else h++; 
			return rval;
}	 	

OPDEF(MoveArista)
{  
			retval rval=0;
			h++;
			if (expressio==0) 
			{
			  if (move2==1)
			  {
				 move2=0;
				 if (test[n]==0) 
				 {
					h1=vert[n].vei[2];
					if (Proc[h1]==0)
					{		
					  MoveArist();
					  rval=T;
					}
				 }
			  }			
			  else rval=-1; 
			}
			else h++; 
			return rval;
}

OPDEF(Res) 
{
			if (expressio==1) h++;
			return 0;
}  

OPDEF(Progn1)  {return (EVAL);}

OPDEF(Progn2)  {return ( EVAL + EVAL);}

OPDEF(Progn3)  {return ( EVAL + EVAL + EVAL);}

OPDEF(Progn4)  {return ( EVAL + EVAL + EVAL + EVAL);}

OPDEF(Progn5)  {return ( EVAL + EVAL + EVAL + EVAL + EVAL);}

//**************************************************************************
///////////////////////// PROBLEM definition


GrilProb::GrilProb(ChromeParams* p) : Problem()
{
	AddF(new ConstFunc(0));                         // Required for GPQUICK, but zero weight

	// Problem specific functions
	AddF(new Function(1,0,100,IfProc_PosteriorEval,"IfProc_Posterior"));
	AddF(new Function(1,0,100,IfProc_AnteriorEval,"IfProc_Anterior"));
	AddF(new Function(1,0,100,IfProc_AristaEval,"IfProc_Arista"));
	AddF(new Function(1,0,150,IfProc_OriEval,"IfProc_Ori"));
 
	AddF(new Function(1,0,100,If_torn_0Eval,"If_torn_0"));
	AddF(new Function(1,0,100,If_torn_1Eval,"If_torn_1"));
	AddF(new Function(1,0,100,If_torn_2Eval,"If_torn_2"));
	AddF(new Function(0,0,100,MoveAnterior,"MoveAnterior"));
	AddF(new Function(0,0,100,MovePosterior,"MovePosterior"));
	AddF(new Function(0,0,100,MoveArista,"MoveArista"));
	
	AddF(new Function(5,0,150,Progn5,"Prog5"));
	AddF(new Function(4,0,150,Progn4,"Prog4"));
	AddF(new Function(3,0,150,Progn3,"Prog3"));
	AddF(new Function(2,0,125,Progn2,"Prog2"));
	AddF(new Function(1,0,10,Progn1,"Prog1")); 

	AddF(new Function(0,0,75,Res,"Res"));

	// Set some parameters
	 p->params[pRepeatEval]=0;                   // no need to repeat, same case each time
	p->params[pMuteConstWt]=0;                      // no constants
	 // Get to Koza type parameters
	 p->params[pMuteWt]=15;                              // less mutation
	p->params[pAnnealMuteWt]=15;                    // disable annealing
	p->params[pAnnealCrossWt] =0;
	p->params[pInitExpr] =10;
	p->params[pMaxExpr] =70;
	// If you need to load problem specific data for evaluation
	// Or load an environment (a map, a scenario)
	// Do it here
 
}

float GrilProb::fitness(Chrome* chrome)
{

	int i,j,s;
	for (i=0;i<ORDRE;i++)
	{
	  Proc[i]=0; Mesh[i]=0;Paso[i]=0;Orden[i]=0;test[i]=0;position[i]=0; 
	}
	float f=0;h=0;
	h1=0;n=0;
	ord=1;pas=1;
	retval answer=0;
	retval s1=0;
	// metode descombrat de la matriu	  
			 for (s=0;s<W;s++)
			 {
				for (i=0;i<ORDRE;i++)				
				{
				  n=position[i];
				  if ( (i==0) || ((Proc[n] != 0) && (Mesh[n]<3)&& (Paso[n]<pas)
							&& (test[n]==0)))
				  {
					 move2=0;move1=0;              // evalua la expressi
					 answer+= chrome->evalAll();   // sencera
					 f=answer;
					 h=0;
					 n=0;
					 expressio=1;          // evalua la seva longitud per
					 s1+= chrome->evalAll();     // minimitzarla
					 expressio=0;
					 f=f-(h*2);         // li resta a la fitness
					 chrome->nfitness->fvalue=f;						 
				  }
				}
				if (ord<=ORDRE-1)
				{
				  pas++;
				  Resetest();
				}
			 }
		
	return f;
}

//**************************************************************************
///////////////////////////////  MAIN

//int main(int, char **)
int EvolveAnt()
// Run with a population of size 2000
// Run for 80,000 evals, or until it finds the answer
// DOS version will exit on keyboard hit
// Every 5 seconds or 1000 evals, print the best answer so far
{
	ChromeParams* params = new ChromeParams();
	Problem* prob=new GrilProb(params);
	Pop* pop;

	cout << "\nGPQUICK Artificial Cube-Conected-Cycles Problem\n";
	
	srand(1);
	pop = new Pop(prob,params,TPB);                // population of size 2000
	a1=0;b1=0;
	int i,j,c1,xx;
	long double a2;

	make_nodes();
	make_arcs();

	int posicion,a3,a6;
	ofstream fin("GRAFICA.TXT",ios::out | ios::app);
	fin<<"\n";
	for (i=0;i<80;i++) fin<<'=';
	fin<<"\nCCC ->"<<Horizontal<<"x"<<ALPHA1<<" en "<<W<<" pasos";
	fin<<"\nNombre de Poblaci "<<TPB<<"\n";

	// Do for 80,000 iterations, or until we find the right answer
	//while (pop->gencount<39000l && !done)  // Portable version - not interruptible
	while (pop->gencount<89000l && !kbhit())  // kbhit IS NOT PORTABLE (Borland specific)
	{   
		// go for 5 seconds, 1000 evals, or until we get a right answer
	  pop->go_until(time(NULL)+5,1000);
				
		// Display the best so far
	  cout << "\n\nAfter " << pop->gencount << " generates, #fitness found = " << pop->BestFitness->fvalue << "\n";
	  pop->pop[pop->BestMember]->write(PRETTY_NONE,cout);
	  cout.flush();
	  a1++;
	  fin<< "\nFitness="<<pop->BestFitness->fvalue;
	  fin<< " After "<<pop->gencount<<" generates";
	  fin<< "  Mitja "<<Vec_mitja[a1];	
	}
	 // Pinta la grfica
	 a6=b1;
	 for(i=0;i<20;i++) graf[i][0]='|';
	 for(i=0;i<b1;i++) graf[20][i]='^';
	 fin<<"\n";
		
	 for(i=0;i<20;i++)
		for(j=1;j<b1;j++) graf[i][j]=' ';	
	 while (b1!=0)
	 {
		a2=Vec_fitness[b1];
		a3=Posicio(&a2);
		graf[20-a3][b1]='*';
		a2=Vec_mitja[b1];
		a3=Posicio(&a2);
		graf[20-a3][b1]='#';		 
		b1--;
	 } 	  			
	 for(i=0;i<21;i++)             
	 {
		fin<<"\n";
		for(j=0;j<a6;j++) fin<<graf[i][j];	
	 }
	
	// Display the best
//
	ofstream of("RESULT.TXT",ios::out | ios::app);
	cout << "\n\nFINAL RESULTS...";
	of<<"\n\nCCC de "<<Horizontal<<"x"<<ALPHA1<<" en "<<W<<" pasos, T="<<T<<" i TPB="<<TPB;
	cout << "\nAfter " << pop->gencount << " generates, #fitness found = " << pop->BestFitness->fvalue << "\n";
	pop->pop[pop->BestMember]->write(PRETTY_NONE,cout);
	cout.flush();
	cout<<"****";pop->pop[pop->BestMember]->SetupEval();
	int y,z,s,k;
	float f=0;
		 // Get the track of the best ant
			
	n=0;h=0;h1=0;
	ord=1;pas=1;expressio=0;
	for (i=0;i<ORDRE;i++)
	{ 
	  Proc[i]=0;Mesh[i]=0;Paso[i]=0;Orden[i]=0;test[i]=0;position[i]=0;
	}									  
	retval answer=0; 
		  
			 for (s=0;s<W;s++)
			 {
				for (i=0;i<ORDRE;i++) 
				{
				  n=position[i];
				  if ( (i==0) || ((Proc[n] != 0) && (Mesh[n]<4)&& (Paso[n]<pas)
						  && (test[n]==0)))
				  {								  // evalua la millor expressi
					 move2=0;h=0;move1=0; 
					 answer+= pop->pop[pop->BestMember]->evalAll();
					 f=answer;
				  }
				}
				if (ord<=ORDRE-1)
				{
				  pas++;
				  Resetest();
				}
			 }
		 // Show the track
	f=answer;
	cout << "\n";
	of << "\n";
	fin<<"\n";
					
	c1=ORDRE/ALPHA1;
	y=0;xx=0;
	while( y<ORDRE)
	{ 
	  xx++;				
	  cout<<Proc[y]<< "\t"<< Paso[y] << "\t ";
	  of<<Proc[y] << "\t"<< Orden[y] << "\t" << Paso[y] <<"\t ";
	  fin<<Proc[y] << "\t"<< Orden[y] << "\t" << Paso[y] <<"\t ";
	  y++;						
	  if ( xx==c1)
	  {   
		 of<<"\n";
		 fin<<"\n";
		 xx=0;
		 cout<<"\n"; 
	  }
	} 				

	cout<<"\nFitness="<<f << "After " << pop->gencount << " generates";		
	of<<"\nFitness="<<f << " After " << pop->gencount<< " generates";
	fin<<"\nFitness="<<f << " After "<<pop->gencount<<" generates";
	cout<<"\n";pop->pop[pop->BestMember]->write(PRETTY_NONE,cout);
	of<<"\n";pop->pop[pop->BestMember]->write(PRETTY_NONE,of);
	fin<<"\n";pop->pop[pop->BestMember]->write(PRETTY_NONE,fin);

	cout << "\nResult in RESULT:TXT";
				
			 // Pinta la grfica
	ofstream fa1("EVOL.TXT",ios::out | ios::app);
	fa1<<"\n";
	for (i=0;i<80;i++) fa1<<'=';
	fa1<<"\n FITXER DEVOLUCIO DE LA TRANSMISIO";
	fa1<<"\n CUBE-CONNECTED-CYCLES amb m="<<ALPHA1<<" en "<<W<<" pasos";
	for(i=0;i<Vertical;i++)
	  for(j=0;j<Horizontal;j++) M_evol[i][j]=' ';	
	for(i=0;i<=W;i++)
	{ 
	  y=0;xx=0;z=0;
	  while( y<ORDRE)
	  { 
		 if (Paso[y]==i)
		 {
			M_evol[z][xx]='*';
			M_evol2[z][xx]=i;
		 }  					  
		 xx++; 
		 y++;	
		 if ( xx==c1)
		 { 								
			z++;
			xx=0;
		 }
	  }
	  fa1<<"\n paso  "<<i<<hex;
	  for(j=0;j<Vertical;j++)
	  { 
		 fa1<<"\n"<<"\t";
		 for(k=0;k<Horizontal;k++)				 
			if (M_evol2[j][k]!='') fa1<<M_evol2[j][k]<<hex;				
			else fa1<<M_evol[j][k];		 			 
	  }
	  fa1<<"\n"<<"\t";
	  for (k=0;k<Horizontal;k++) fa1<<'^';
	  for(j=0;j<Vertical;j++)
		 for(k=0;k<Horizontal;k++)
			if (M_evol[j][k]=='*')
			{ 
			  M_evol2[j][k]='';
			  M_evol[j][k]='';
			}
	}			
	fa1.close();						
	fin.close();                 		 
	of.close();	 

	delete pop;
	delete prob;
	delete params;
	return 0;
}

int main(int, char **)
{
	EvolveAnt();
	return 0;
}
  
