// COMPILA BE a  rscn
//     c++ -o gp7  but7ev.cxx chrome.cxx primitiv.cxx selector.cxx
// atencio, a chrome.cxx, GRAFICA  ha de ser 0
//
//   Per evolucionar a partir de zero
//   evolucio = 1    i  en el fitxer CHROME.CPP
//			#define grafica 1/0  segons si es vol la grfica o no
//       #define mesh   0
//       #define toro   0
//       #define btfd   0
//       #define btfdp  0
//       #define btfnd  0
//       #define btfndp 0
//       #define ccc    0
//
//   Per introduir la expressio trobada
//   evolucio = 0     i en el fitxer CHROME:CPP
//			#define grafica 1/0 segons es vulgui trobar la grfica
//       #define mesh   0                                  o no
//       #define toro   0
//       #define btfd   0
//       #define btfdp  0
//       #define btfnd  1
//       #define btfndp 0
//       #define ccc    0

//***************************************************************************
//  GGGbndm7.cpp  trevalla sobre un graf BUTTERFLY amb d= ALPHA1
//  la evoluci de la transmisi es troba en el fitxer EVOL.TXT
//  la grfica de les fitness i la expressi final a GRAFICA.TXT
//  la expressi final tamb es guarda al fitxer RESULT:TXT
//***************************************************************************
#include "pch.h"
#include "chrome.h"
#include "primitiv.h"

extern char scratch[100];
#ifdef FASTEVAL
	extern evalnode* IpGlobal;
	extern Chrome* ChromeGlobal;
#endif


//**************************************************************************
// Define your Problem class

class GrilProb : public Problem {
public:
	GrilProb(ChromeParams* p);               // initialize functions, parameters, and data
	float fitness(Chrome* chrome);  // Driving ingredient - GP fitness function
};


//**************************************************************************
// static variables that make up the evaluation environment
// Build your environment here as statics
// where the evaluation functions can get to the data
		 
#define W 12                  // nombre de pases
#define T 350 			        // increment positiu de la fitness
#define TPB 800             // tamany total de poblaci
#define ORDRE 896            // nombre de nodes
#define ALPHA1 7             // es la d ->BFd
#define ALPHA2 2             // perque s en binari
#define LONGMOT 8            // nombre de camps utilitzats per anomenar cada node
#define GRAU 2               // dona el nombre de veins
#define Horizontal ORDRE/ALPHA1 // n de nodes per cada fila
#define Vertical ALPHA1         // n de nodes per columna

int test[ORDRE];             // prohibeix al node tornar a transmetre informacio en un mateix pas
int Orden[ORDRE];            // pas de la seqncia de lalgoritme
int Paso[ORDRE];             // etapa de pas de linformaci
int Mesh[ORDRE];             // paquets transmesos pel node
int Proc[ORDRE];             // procedncia del paquet rebut
int position[ORDRE];
unsigned char M_evol[ALPHA1][ORDRE/ALPHA1]; // espai on es pinta la evolucio
int M_evol2[ALPHA1][ORDRE/ALPHA1];
int pas,ord,b1,n,h1,a1,a5,sup,move2,move1;
int expressio=0;             // habilita levaluacio del tamany de lexpressio
int h=0;                     // comptador del tamany de lexpressio
int evolucio=1;

//**************************************************************************
// Estructures

typedef struct vertex {     // estructura per definir els nodes
	 char name[LONGMOT];     // camp pel nom
	 int vei[GRAU*2];        // camp per identificar els veins
	 };
	 
vertex vert[ORDRE];         // es defineix un vector de vrtex (nodes)
int numnode[ALPHA1][ALPHA2][ALPHA2][ALPHA2][ALPHA2][ALPHA2][ALPHA2][ALPHA2]; // guarda el node segons la seva
															// identificaci

//**************************************************************************
// Data handling functions


void make_nodes()           // construeix els nodes amb una forma a,x,y,z
{                           //                       per  exemple 0.1 0 1
	int i0,i1,i2,i3,i4,i5,i6,i7,i,n;     //                           vertical<-.->horitzontal 
	n=0;
	for (i0=0;i0<ALPHA1;i0++)
	  for (i1=0;i1<ALPHA2;i1++)
		 for (i2=0;i2<ALPHA2;i2++)
			for (i3=0;i3<ALPHA2;i3++)
			  for (i4=0;i4<ALPHA2;i4++)
				 for (i5=0;i5<ALPHA2;i5++)
					for (i6=0;i6<ALPHA2;i6++)
					  for (i7=0;i7<ALPHA2;i7++)
					  {
						 vert[n].name[0]=i0;
						 vert[n].name[1]=i7;
						 vert[n].name[2]=i6;
						 vert[n].name[3]=i5;                    
						 vert[n].name[4]=i4;               
						 vert[n].name[5]=i3;                    
						 vert[n].name[6]=i2;                 
						 vert[n].name[7]=i1;                                    
						 numnode[i0][i7][i6][i5][i4][i3][i2][i1]=n;
						 n++;
					  }
}

void make_arcs()
{
	int x[LONGMOT],n,i;
	for (n=0;n<ORDRE;n++)
	{
	  for (i=0;i<LONGMOT;i++) x[i]=vert[n].name[i];
	  vert[n].vei[0]=numnode[(x[0]+1)%ALPHA1][x[1]][x[2]][x[3]][x[4]][x[5]][x[6]][x[7]]; // vei vertical inferior
	  vert[n].vei[2]=numnode[(x[0]+ALPHA1-1)%ALPHA1][x[1]][x[2]][x[3]][x[4]][x[5]][x[6]][x[7]]; // vei vertical superior
	  if (x[0]==0) x[1]= (x[1]+1)%ALPHA2;
	  if (x[0]==1) x[2]= (x[2]+1)%ALPHA2;    // realitzaci dels complementaris
	  if (x[0]==2) x[3]= (x[3]+1)%ALPHA2;
	  if (x[0]==3) x[4]= (x[4]+1)%ALPHA2;
	  if (x[0]==4) x[5]= (x[5]+1)%ALPHA2;
	  if (x[0]==5) x[6]= (x[6]+1)%ALPHA2;
	  if (x[0]==6) x[7]= (x[7]+1)%ALPHA2;
	  vert[n].vei[1]=numnode[(x[0]+1)%ALPHA1][x[1]][x[2]][x[3]][x[4]][x[5]][x[6]][x[7]]; // vei diagonal inferior
	  for (i=0;i<LONGMOT;i++) x[i]=vert[n].name[i];
	  if (x[0]==0) x[7]= (x[7]+1)%ALPHA2;
	  if (x[0]==1) x[1]= (x[1]+1)%ALPHA2;    // realitzacio dels complementaris
	  if (x[0]==2) x[2]= (x[2]+1)%ALPHA2;
	  if (x[0]==3) x[3]= (x[3]+1)%ALPHA2;
	  if (x[0]==4) x[4]= (x[4]+1)%ALPHA2;
	  if (x[0]==5) x[5]= (x[5]+1)%ALPHA2;
	  if (x[0]==6) x[6]= (x[6]+1)%ALPHA2;
	  vert[n].vei[3]=numnode[(x[0]+ALPHA1-1)%ALPHA1][x[1]][x[2]][x[3]][x[4]][x[5]][x[6]][x[7]]; // vei diagonal superior
	}
}	  
					  
retval ProcVertSup()   // evalua la procedencia del paquet rebut
{ 
	retval rval=0;                       // si es un '2' indica procedncia
	rval= (Proc[n] == 2) ;    // vertical superior
	return rval;
}

retval ProcDiagSup()   // evalua la procedencia del paquet rebut
{ 
	retval rval=0;                       // si s un '1'  indica procedncia
	rval= (Proc[n] == 1);    // diagonal superior
	return rval;
}

retval ProcVertInf()   // evalua la procedencia del paquet rebut
{ 
	retval rval=0;                       // si s un '4'  indica procedncia
	rval= (Proc[n] == 4);    // vertical inferior
	return rval;
}

retval ProcDiagInf()   // evalua la procedencia del paquet rebut
{ 
	retval rval=0;                       // si s un  '3' indica procedncia
	rval= (Proc[n] == 3);    // diagonal inferior
	return rval;
}
	
void Resetest()          // posa a zero la matriu 'test' per poder realitzar
{                       // un altre pas
	int i;
	for (i=0;i<ORDRE;i++) test[i]=0;
}							

void MoveDiag()
{
			Mesh[n]++;			      // incrementa el comptador de transmisions del node n
			if (sup==0) Proc[h1]=1;
			else Proc[h1]=3;       // marca la procedncia en el node que rep la info
			Paso[h1]=pas;
			test[n]=1;             // prohibeix al node n tornar a transmetre en aquest pas
			position[ord]=h1;
			Orden[h1]=ord;ord++;   // guarda lordre en que ha rebut la informaci
}				 

void MoveVert()
{
			Mesh[n]++;
			if (sup==0) Proc[h1]=2;
			else Proc[h1]=4;
			Paso[h1]=pas;
			test[n]=1;
			position[ord]=h1;
			Orden[h1]=ord;ord++;
}			
	 
//**************************************************************************
//////////////////////////  Problem specific functions

// Use the OPDEF,EVAL,IP and CURCHROME defines
// and the code will recompile for different eval methods
	  
OPDEF(IfProc_OriEval)     // mira si al procedencia s lorigen
{                         // permet quatre moviments
			retval rval=0;
			move1=0;move2=0;       
			if (expressio==1) h++;  // comptador del tamany de lxpressi
			if ((n==0) || (expressio==1))
			{
			  Proc[0]=5;
			  move1=1;  // condici que obliga a mirar la procedencia abans de moures
			  rval=EVAL;
			}
			else {  
			  IP++;
			  TRAVERSE();    // Jump the first expression
			  IP--;   		  // Back up for EVAL
			}	
			return rval;
}

	class IfProc_Ori : public Function {
	public:
	IfProc_Ori() {strcpy(name,"IFPROC_ORI");argnum=1;varnum=0;weight=100;
	evalfunc=IfProc_OriEval;};
	};

OPDEF(IfProc_DiagInfEval)
{    
			retval rval=0;
			move1=0;move2=0;
			if (expressio==1) h++;
			if ((ProcDiagInf()) || (expressio==1))
			{
			  move1=1;
			  rval=EVAL;			  
			}
			else {  
			  IP++;
			  TRAVERSE();
			  IP--;						  // Back up for EVAL				  
			}
			return rval;
}

	class IfProc_DiagInf : public Function {
	public:
	IfProc_DiagInf() {strcpy(name,"IFPROC_DIAGINF");argnum=1;varnum=0;weight=100;
	evalfunc=IfProc_DiagInfEval;};
	};
						
 OPDEF(IfProc_DiagSupEval)
{    
			retval rval=0;
			move1=0;move2=0;
			if (expressio==1) h++;
			if ((ProcDiagSup()) || (expressio==1))
			{
			  move1=1;
			  rval=EVAL;			  
			}
			else {  
			  IP++;
			  TRAVERSE();
			  IP--;					     // Back up for EVAL				  
			}
			return rval;
}

	class IfProc_DiagSup : public Function {
	public:
	IfProc_DiagSup() {strcpy(name,"IFPROC_DIAGSUP");argnum=1;varnum=0;weight=100;
	evalfunc=IfProc_DiagSupEval;};
	};
						
		  
	  
OPDEF(IfProc_VInfEval)
{ 
			retval rval=0;
			move1=0; move2=0;
			if (expressio==1) h++;
			if ((ProcVertInf()) || (expressio==1))
			{  
			  move1=1;
			  rval=EVAL;
			}
			else {  
			  IP++;
			  TRAVERSE();
			  IP--;			  	
			}		 
			return rval;
}

	class IfProc_VInf : public Function {
	public:
	IfProc_VInf() {strcpy(name,"IFPROC_VINF");argnum=1;varnum=0;weight=100;
	evalfunc=IfProc_VInfEval;};
	};

OPDEF(IfProc_VSupEval)
{ 
			retval rval=0;
			move1=0;move2=0;
			if (expressio==1) h++;
			if ((ProcVertSup()) || (expressio==1))
			{  
			  move1=1;
			  rval=EVAL;
			}
			else {  
			  IP++;
			  TRAVERSE();
			  IP--;			  	
			}		 
			return rval;
}

	class IfProc_VSup : public Function {
	public:
	IfProc_VSup() {strcpy(name,"IFPROC_VSUP");argnum=1;varnum=0;weight=100;
	evalfunc=IfProc_VSupEval;};
	};

 OPDEF(If_torn_0Eval)
{ 
			retval rval=0;
			move2=0;
			if (expressio==1) h++;
			if ((move1==1) || (expressio==1))
			{   
			  if ((Mesh[n]==0) || (expressio==1))
			  {  
				 move2=1;
				 rval=EVAL;
			  }
			  else {  
				 IP++;
				 TRAVERSE();
				 IP--;			  	
			  }
			}
			else rval=-1;	 		 
			return rval;
}

	class If_torn_0 : public Function {
	public:
	If_torn_0() {strcpy(name,"IF_TORN_0");argnum=1;varnum=0;weight=100;
	evalfunc=If_torn_0Eval;};
	};

OPDEF(If_torn_1Eval)
{ 
			retval rval=0;
			move2=0;
			if (expressio==1) h++;
			if ((move1==1) || (expressio==1))
			{   
			  if ((Mesh[n]==1) || (expressio==1))
			  {  
				 move2=1;
				 rval=EVAL;
			  }
			  else {  
				 IP++;
				 TRAVERSE();
				 IP--;			  	
			  }
			}
			else rval=-1;	 		 
			return rval;
}

	class If_torn_1 : public Function {
	public:
	If_torn_1() {strcpy(name,"IF_TORN_1");argnum=1;varnum=0;weight=100;
	evalfunc=If_torn_1Eval;};
	};

OPDEF(If_torn_2Eval)
{ 
			retval rval=0;
			move2=0;
			if (expressio==1) h++;
			if ((move1==1) || (expressio==1))
			{   
			  if ((Mesh[n]==2) || (expressio==1))
			  {  
				 move2=1;
				 rval=EVAL;
			  }
			  else {  
				 IP++;
				 TRAVERSE();
				 IP--;			  	
			  }
			}
			else rval=-1;	 		 
			return rval;
}

	class If_torn_2 : public Function {
	public:
	If_torn_2() {strcpy(name,"IF_TORN_2");argnum=1;varnum=0;weight=100;
	evalfunc=If_torn_2Eval;};
	};

OPDEF(If_torn_3Eval)
{ 
			retval rval=0;
			move2=0;
			if (expressio==1) h++;
			if ((move1==1) || (expressio==1))
			{   
			  if ((Mesh[n]==3) || (expressio==1))
			  {  
				 move2=1;
				 rval=EVAL;
			  }
			  else {  
				 IP++;
				 TRAVERSE();
				 IP--;			  	
			  }
			}
			else rval=-1;	 		 
			return rval;
}

	class If_torn_3 : public Function {
	public:
	If_torn_3() {strcpy(name,"IF_TORN_3");argnum=1;varnum=0;weight=100;
	evalfunc=If_torn_3Eval;};
	};


OPDEF(MoveDiagInf)
{
			retval rval=0;
			h++;
			if (expressio==0) 
			{ 
			  if (move2==1) 
			  {
				 if (test[n]==0)
				 {
					h1=vert[n].vei[1];
					if  (Proc[h1]==0)
					{
					  MoveDiag();
					  rval=T;
					}
				 } 
			  }		
			  else rval=-1;
			}
			else h++; 
			return rval;
}	 	

OPDEF(MoveDiagSup)
{
			retval rval=0;
			sup=1;h++;
			if (expressio==0) 
			{ 
			  if (move2==1)
			  {
				 if (test[n]==0)
				 {
					h1=vert[n].vei[3];
					if  (Proc[h1]==0)
					{
					  MoveDiag();
					  rval=T;
					}
				 } 
			  }		
			  else rval=-1;
			}
			else h++; 
			sup=0;
			return rval;
}	 	


OPDEF(MoveVertInf)
{  
			retval rval=0;
			h++;
			if (expressio==0)
			{
			  if (move2==1)
			  {
				 if (test[n]==0) 
				 {
					h1=vert[n].vei[0];
					if (Proc[h1]==0)
					{		
					  MoveVert();
					  rval=T;
					}
				 }
			  }			
			  else rval=-1; 
			}
			else h++; 
			return rval;
}

 OPDEF(MoveVertSup)
{
			retval rval=0;
			sup=1;h++;
			if (expressio==0)
			{ 
			  if (move2==1)
			  {
				 if (test[n]==0) 
				 {
					h1=vert[n].vei[2];
					if  (Proc[h1]==0)
					{
					  MoveVert();
					  rval=T;
					}
				 }
			  }		
			  else rval=-1;
			}
			else h++;                                        
			sup=0;
			return rval;
}	 	

OPDEF(Res) 
{
			if (expressio==1) h++;
			return 0;
}


OPDEF(Progn1)  {return (EVAL);}

OPDEF(Progn2)  {return ( EVAL + EVAL);}

OPDEF(Progn3)  {return ( EVAL + EVAL + EVAL);}

OPDEF(Progn4)  {return ( EVAL + EVAL + EVAL + EVAL);}

OPDEF(Progn5)  {return ( EVAL + EVAL + EVAL + EVAL + EVAL);}

OPDEF(Progn6)  {return ( EVAL + EVAL + EVAL + EVAL + EVAL + EVAL);}

//**************************************************************************
///////////////////////// PROBLEM definition


GrilProb::GrilProb(ChromeParams* p) : Problem()
{
	AddF(new ConstFunc(0));                         // Required for GPQUICK, but zero weight

	// Problem specific functions
	AddF(new Function(1,0,100,IfProc_DiagInfEval,"IfProc_DiagInf"));
	AddF(new Function(1,0,100,IfProc_DiagSupEval,"IfProc_DiagSup"));
	AddF(new Function(1,0,100,IfProc_VInfEval,"IfProc_VInf"));
	AddF(new Function(1,0,100,IfProc_VSupEval,"IfProc_VSup"));
	AddF(new Function(1,0,150,IfProc_OriEval,"IfProc_Ori"));
	 
	AddF(new Function(1,0,100,If_torn_0Eval,"If_torn_0"));
	AddF(new Function(1,0,100,If_torn_1Eval,"If_torn_1"));
	AddF(new Function(1,0,100,If_torn_2Eval,"If_torn_2"));
	AddF(new Function(1,0,100,If_torn_3Eval,"If_torn_3"));
	AddF(new Function(0,0,100,MoveDiagInf,"MoveDiagInf"));
	AddF(new Function(0,0,100,MoveDiagSup,"MoveDiagSup"));
	AddF(new Function(0,0,100,MoveVertInf,"MoveVertInf"));
	AddF(new Function(0,0,100,MoveVertSup,"MoveVertSup"));
 
	AddF(new Function(6,0,150,Progn6,"Prog6"));	
	AddF(new Function(5,0,150,Progn5,"Prog5"));
	AddF(new Function(4,0,150,Progn4,"Prog4"));
	AddF(new Function(3,0,150,Progn3,"Prog3"));
	AddF(new Function(2,0,125,Progn2,"Prog2"));
	AddF(new Function(1,0,10,Progn1,"Prog1")); 

	AddF(new Function(0,0,75,Res,"Res"));
	
	// Set some parameters
	p->params[pRepeatEval] = 0;                   // no need to repeat, same case each time
	p->params[pMuteConstWt] = 0;                      // no constants
	 // Get to Koza type parameters
	p->params[pMuteWt] = 15;                              // less mutation
	p->params[pAnnealMuteWt] = 15;                    // disable annealing
	p->params[pAnnealCrossWt] = 0;
	p->params[pInitExpr] = 10;
	p->params[pMaxExpr] = 70;
	// If you need to load problem specific data for evaluation
	// Or load an environment (a map, a scenario)
	// Do it here
 
}

float GrilProb::fitness(Chrome* chrome)
{

	int i,j,s;
	for (i=0;i<ORDRE;i++)
	{
	  Proc[i]=0; Mesh[i]=0;Paso[i]=0;Orden[i]=0;test[i]=0;position[i]=0;
	}
	float f=0;h=0;
	h1=0;n=0;
	ord=1;sup=0; pas=1;
	retval answer=0;
	retval s1=0;
	//mecanisme descombrat de la xarxa a travs dun vector	  
			 for (s=0;s<W;s++)
			 {
				for (i=0;i<ORDRE;i++)				
				{
				  n=position[i];
				  if ( (i==0) || ((Proc[n] != 0) && (Mesh[n]<4)&& (Paso[n]<pas)
							&& (test[n]==0)))
				  {
					 move2=0;move1=0;              // evalua la expressi
					 answer+= chrome->evalAll();   // sencera
					 f=answer;
					 h=0;
					 n=0;
					 expressio=1;          // evalua la seva longitud per
					 s1+= chrome->evalAll();     // minimitzarla
					 expressio=0;
					 f=f-(h*2);         // li resta a la fitness
					 chrome->nfitness->fvalue=f;						 
				  }
				}
				if (ord<=ORDRE-1)
				{
				  pas++;
				  Resetest();
				}
			 }		
	return f;
}

//**************************************************************************
///////////////////////////////  MAIN

//int main(int, char **)
int EvolveAnt()
// Run with a population of size 2000
// Run for 80,000 evals, or until it finds the answer
// DOS version will exit on keyboard hit
// Every 5 seconds or 1000 evals, print the best answer so far

{
	ChromeParams* params = new ChromeParams();
	Problem* prob=new GrilProb(params);
	Pop* pop;

	cout << "\nGPQUICK Artificial Butterfly Problem\n";

	srand(1); // en lloc de rndomize(); que donava error al compilar
	pop = new Pop(prob,params,TPB);                // population of size 2000
	a1=0;b1=0;
	int i,j,c1,xx;

	make_nodes();
	make_arcs();


	// Do for 80,000 iterations, or until we find the right answer
	//while (pop->gencount<39000l && !done)  // Portable version - not interruptible

	while (pop->gencount<89000l)  // kbhit IS NOT PORTABLE (Borland specific)
	{                 
		// go for 5 seconds, 1000 evals, or until we get a right answer
	  pop->go_until(time(NULL)+600,1000);
				
		// Display the best so far
	  cout << "\n\nAfter " << pop->gencount << " generates, #fitness found = " << pop->BestFitness->fvalue << "\n";
	  pop->pop[pop->BestMember]->write(PRETTY_NONE,cout);
	  cout.flush();
	  a1++;	
	}

	// Display the best
//
	ofstream of("RESULT.TXT",ios::out | ios::app);
	cout << "\n\nFINAL RESULTS...";
	of<<"\n\nButterfly de "<<Horizontal<<"x"<<ALPHA1<<" en "<<W<<" pasos, T="<<T<<" i TPB="<<TPB;
	cout << "\nAfter " << pop->gencount << " generates, #fitness found = " << pop->BestFitness->fvalue << "\n";
	pop->pop[pop->BestMember]->write(PRETTY_NONE,cout);
	cout.flush();
	cout<<"****";pop->pop[pop->BestMember]->SetupEval();
	int y,z,s,k;
	float f=0;		

		 // Get the track of the best 
			
	n=0;h=0;h1=0;
	ord=1;pas=1;expressio=0;
	sup=0;
	for (i=0;i<ORDRE;i++)
	{
	  Proc[i]=0;Mesh[i]=0;Paso[i]=0;Orden[i]=0;test[i]=0;position[i]=0;
	}							  
	retval answer=0; 
		  
			 for (s=0;s<W;s++)
			 {
				for (i=0;i<ORDRE;i++) 
				{
				  n=position[i];
				  if ( (i==0) || ((Proc[n] != 0) && (Mesh[n]<4)&& (Paso[n]<pas)
						  && (test[n]==0)))
				  {								  // evalua la millor expressi
					 move2=0;h=0;move1=0; 
					 answer+= pop->pop[pop->BestMember]->evalAll();
					 f=answer;
				  }
				}				
				if (ord<=ORDRE-1)
				{
				  pas++;
				  Resetest();
				}
			 }
			 f=answer;
		 // Show the track
			
	cout << "\n";
	of << "\n";
			
	c1=ORDRE/ALPHA1;
	y=0;xx=0;
	while( y<ORDRE)
	{ 
	  xx++;
//	  cout<<Proc[y]<< "\t"<< Paso[y] << "\t ";
	  of<<Proc[y]<< "\t"<< Paso[y] <<"\t ";
	  y++;						
	  if ( xx==c1)
	  {
		 of<<"\n";
		 xx=0;
		 cout<<"\n";
	  }			
	} 
			
	cout<<"\nFitness="<<f << "After " << pop->gencount << " generates";		
	of<<"\nFitness="<<f << " After " << pop->gencount<< " generates";
	cout<<"\n";pop->pop[pop->BestMember]->write(PRETTY_NONE,cout);
	of<<"\n";pop->pop[pop->BestMember]->write(PRETTY_NONE,of);

	cout << "\nResult in RESULT:TXT";
	 
			 // Pinta la grfica
	ofstream fa1("EVOL.TXT",ios::out | ios::app);
	fa1<<"\n";
	for (i=0;i<80;i++) fa1<<'=';
	fa1<<"\n FITXER DEVOLUCIO DE LA TRANSMISIO";
	fa1<<"\n BUTTERFLY amb d="<<ALPHA1<<" en "<<W<<" pasos";
	for(i=0;i<Vertical;i++)
	  for(j=0;j<Horizontal;j++) M_evol[i][j]=' ';	
	for(i=0;i<=W;i++)
	{ 
	  y=0;xx=0;z=0;
	  while( y<ORDRE)
	  { 				
		 if (Paso[y]==i)
		 {
			M_evol[z][xx]='*';
			M_evol2[z][xx]=i;	
		 }									  
		 xx++; 
		 y++;	
		 if ( xx==c1 )
		 { 								
			z++;
			xx=0;
		 }
	  }
	  fa1<<"\n paso  "<<i<<hex;
	  for(j=0;j<Vertical;j++)
	  {
		 fa1<<"\n"<<"\t";
		 for(k=0;k<Horizontal;k++)	
			if (M_evol2[j][k]!='') fa1<<M_evol2[j][k]<<hex;				
			else fa1<<M_evol[j][k];		 			 			 
	  }
	  fa1<<"\n"<<"\t";
	  for (k=0;k<Horizontal;k++) fa1<<'^';
		 for(j=0;j<Vertical;j++)
			for(k=0;k<Horizontal;k++)
			  if (M_evol[j][k]=='*')
			  { 
				 M_evol2[j][k]='';
				 M_evol[j][k]='';
			  } 
	}
	fa1.close();							 
	of.close();	 

	delete pop;
	delete prob;
	delete params;
	return 0;
}

int main(int, char **)
{
	EvolveAnt();
	return 0;
}
  
