//   Per evolucionar a partir de zero
//   evolucio = 1    i  en el fitxer CHROME.CPP
//			#define grafica 1/0  segons si es vol la grfica o no
//       #define mesh   0
//       #define toro   0
//       #define btfd   0
//       #define btfnd  0
//       #define ccc    0
//
//   No hi ha per introduir la expressio trobada

// funciona amb T 300 InitExpr 7 MaxExpr 70
//***************************************************************************
//  GGGhcm5  trevalla sobre un graf HIPERCUB amb d= 5
//  la evoluci de la transmisi es troba en el fitxer EVOL.TXT
//  la grfica de les fitness i la expressi final a GRAFICA.TXT
//  la expressi final tamb es guarda al fitxer RESULT:TXT
//***************************************************************************

#include "pch.h"
#include "chrome.h"
#include "primitiv.h"

extern char scratch[100];
#ifdef FASTEVAL
	extern evalnode* IpGlobal;
	extern Chrome* ChromeGlobal;
#endif

//**************************************************************************
// Define your Problem class

class GrilProb : public Problem {
public:
	GrilProb(ChromeParams* p);               // initialize functions, parameters, and data
	float fitness(Chrome* chrome);  // Driving ingredient - GP fitness function
};

//**************************************************************************
// static variables that make up the evaluation environment
// Build your environment here as statics
// where the evaluation functions can get to the data
		 
#define W 5             // nombre de pases
#define T 100 	        // increment positiu de la fitness
#define TPB 1000        // tamany total de poblaci
#define ORDRE 32        // nombre de nodes
#define ALPHA2 2        // perque s en binari
#define LONGMOT 5       // nombre de camps utilitzats per anomenar cada node
#define GRAU  5         // dona el nombre de veins

int test[ORDRE];  // prohibeix al node tornar a transmetre informacio en un mateix pas
int Orden[ORDRE]; // pas de la seqncia de lalgoritme
int Paso[ORDRE];  // etapa de pas de linformaci
int Mesh[ORDRE];  // paquets transmesos pel node
int Proc[ORDRE];  // paritat del node
int Proced[ORDRE];// procedncia del paquet rebut
int position[ORDRE];
int utilitzat[ORDRE];
long double Vec_fitness[400]; // guarda les fitness per fer la grfica
long double Vec_mitja[400];   // guarda la mitja de les fitness de la poblacio total
unsigned char graf[21][400];  // es l`espai on es pinta la grfica
int major,pas,ord,b1,n,h1,a1,a5,Cambio,change,sup,par,move2,move1;
int expressio=0;              // habilita levaluacio del tamany de lexpressio
int h=0;                      // comptador del tamany de lexpressio
int evolucio=1;               // 1  evoluci

//**************************************************************************
// Estructures

typedef struct vertex {     // estructura per definir els nodes
	 char name[LONGMOT];     // camp pel nom
	 int vei[LONGMOT];        // camp per identificar els veins
	 };
	 
vertex vert[ORDRE];         // es defineix un vector de vrtex (nodes)
int numnode[ALPHA2][ALPHA2][ALPHA2][ALPHA2][ALPHA2]; // guarda el node segons la seva
															// identificaci
//**************************************************************************
// Data handling functions

void make_nodes()           // construeix els nodes amb una forma a,x,y,z
{                           //                       per  exemple 0.1 0 1
	int i1,i2,i3,i4,i5,i,n;     //                           vertical<-.->horitzontal 
	n=0;
	  for (i1=0;i1<ALPHA2;i1++)
		 for (i2=0;i2<ALPHA2;i2++)
			for (i3=0;i3<ALPHA2;i3++)
			  for (i4=0;i4<ALPHA2;i4++)
				 for (i5=0;i5<ALPHA2;i5++)
				 {
					vert[n].name[0]=i5;
					vert[n].name[1]=i4;
					vert[n].name[2]=i3;
					vert[n].name[3]=i2;
					vert[n].name[4]=i1;	
					numnode[i5][i4][i3][i2][i1]=n;
					n++;
				 }
}

void make_arcs()
{
	int x[LONGMOT],n,i;
	for (n=0;n<ORDRE;n++)
	{
	  for (i=0;i<LONGMOT;i++) x[i]=vert[n].name[i];	
	  vert[n].vei[0]=numnode[(x[0]+1)%ALPHA2][x[1]][x[2]][x[3]][x[4]];
	  vert[n].vei[1]=numnode[x[0]][(x[1]+1)%ALPHA2][x[2]][x[3]][x[4]];  	  // realitzaci dels complementaris
	  vert[n].vei[2]=numnode[x[0]][x[1]][(x[2]+1)%ALPHA2][x[3]][x[4]];  	  	 	 
	  vert[n].vei[3]=numnode[x[0]][x[1]][x[2]][(x[3]+1)%ALPHA2][x[4]];  	  	 	 
	  vert[n].vei[4]=numnode[x[0]][x[1]][x[2]][x[3]][(x[4]+1)%ALPHA2]; 
	}		
}	  
					  
int Posicio(long double *ma)        // introdueix els valors de la fitness dintre del rang de la grfica
{
	int posicio;
	posicio=(*ma*21)/((ORDRE-1)*T);
	return posicio;
}
retval ProcMajor()   // evalua la procedencia del paquet rebut
{ 
	retval rval=0;                       // si es un '1' indica procedncia
	rval= (Proced[n] == 1) ;    // un node major
	return rval;
}

retval ProcMenor()   // evalua la procedencia del paquet rebut
{ 
	retval rval=0;                       // si s un  '2' indica procedncia
	rval= (Proced[n] == 2);    // dun node menor
	return rval;
}
						
void Resetest()          // posa a zero la matriu 'test' per poder realitzar
{                       // un altre pas
	int i;
	for (i=0;i<ORDRE;i++) test[i]=0;
}

int pot(int *i,int *n)
{
	int sj,kj,pj;
	kj=0;
	sj=vert[*n].name[*i];
	pj=1;
	if ((sj==1) && (*i==0)) kj=1;
	if ((sj==1) && (*i!=0))
	{  
	  for (int g=0;g<*i;g++) pj=pj*2;
	  kj=pj;
	}
	return kj;
}		
	
void Compare()
{
	int i,k,g,p,s;
	k=0;p=0;g=0;s=0;
	for (i=0;i<LONGMOT;i++)
	{
	  k=pot(&i,&n);
	  g=g+k;
	  p=pot(&i,&h1);
	  s=s+p;
	}
	if (g>s) major=n;
	else major=h1;
}	 	

void Major()
{
	int i,f,m,s,k,p;
	f=0;
	for (m=0;m<LONGMOT;m++)
	{ 
	  k=0;s=0;
	  p=vert[n].vei[m];
	  for (i=0;i<LONGMOT;i++) 
	  {
		 k=pot(&i,&p); 
		 s=s+k;
	  } 
	  if ((s>f) && (utilitzat[p]==0)) 
	  {
		 f=s;h1=p;
	  }
	}
}

void Menor()
{
	int i,f,m,s,k,p;
	f=32;
	for (m=0;m<LONGMOT;m++)
	{ 
	  k=0;s=0;
	  p=vert[n].vei[m];
	  for (i=0;i<LONGMOT;i++)
	  {
		 k=pot(&i,&p);
		 s=s+k; 
	  }
	  if ((s<f) && (s!=0) && (utilitzat[p]==0))
	  {
		 f=s;h1=p;
	  }
	}
}
								
void MovMajor()
{
	Mesh[n]++;			      // incrementa el comptador de transmisions del node n
	Proc[h1]=1;            // marca la procedncia en el node que rep la info
	Paso[h1]=pas;
	test[n]=1;             // prohibeix al node n tornar a transmetre en aquest pas
	position[ord]=h1;
	Orden[h1]=ord;ord++;   // guarda lordre en que ha rebut la informaci
	utilitzat[h1]=1;
}				 

void MovMenor()
{
	Mesh[n]++;
	Proc[h1]=2;
	Paso[h1]=pas;
	test[n]=1;
	position[ord]=h1;
	Orden[h1]=ord;ord++;
	utilitzat[h1]=1;
}

void Procedencia()
{  
	Compare();
	if (n==major) Proced[h1]=1;
	else Proced[h1]=2;
}
				 
//**************************************************************************
//////////////////////////  Problem specific functions

// Use the OPDEF,EVAL,IP and CURCHROME defines
// and the code will recompile for different eval methods
	  
OPDEF(IfProc_OriEval)     // mira si al procedencia s lorigen
{                         // permet quatre moviments
			retval rval=0;
			move2=0;move1=0;       
			if (expressio==1) h++;  // comptador del tamany de lxpressi
			if ((n==0) || (expressio==1))
			{
			  Proc[0]=5;
			  move1=1;  // condici que obliga a mirar la procedencia abans de moures
			  rval=EVAL;
			}
			else {  
			  IP++;
			  TRAVERSE();    // Jump the first expression
			  IP--;   		  // Back up for EVAL
			}
			return rval;
}

	class IfProc_Ori : public Function {
	public:
	IfProc_Ori() {strcpy(name,"IFPROC_ORI");argnum=1;varnum=0;weight=100;
	evalfunc=IfProc_OriEval;};
	};

OPDEF(IfProc_MajorEval)
{    
			retval rval=0;
			move2=0;move1=0;
			if (expressio==1) h++;
			if ((ProcMajor()) || (expressio==1))
			{
			  move1=1;
			  rval=EVAL;				  
			}
			else {  
			  IP++;
			  TRAVERSE();
			  IP--;								 // Back up for EVAL				  
			}
			return rval;
}

	class IfProc_Major : public Function {
	public:
	IfProc_Major() {strcpy(name,"IFPROC_MAJOR");argnum=1;varnum=0;weight=100;
	evalfunc=IfProc_MajorEval;};
	};
						
 OPDEF(IfProc_MenorEval)
{    
			retval rval=0;
			move2=0;move1=0;
			if (expressio==1) h++;
			if ((ProcMenor()) || (expressio==1))
			{
			  move1=1;
			  rval=EVAL;				  
			}
			else {  
			  IP++;
			  TRAVERSE();
			  IP--;								  // Back up for EVAL				  
			}
			return rval;
}

	class IfProc_Menor : public Function {
	public:
	IfProc_Menor() {strcpy(name,"IFPROC_MENOR");argnum=1;varnum=0;weight=100;
	evalfunc=IfProc_MenorEval;};
	};
						
		  
 OPDEF(If_torn_0Eval)
{ 
			retval rval=0;
			move2=0;
			if (expressio==1) h++;
			if ((move1==1) || (expressio==1))
			{   
			  if ((Mesh[n]==0) || (expressio==1))
			  {  
				 move2=1;
				 rval=EVAL;
			  }
			  else {  
				 IP++;
				 TRAVERSE();
				 IP--;			  	
			  }
			}
			else rval=-1;	 		 
			return rval;
}

	class If_torn_0 : public Function {
	public:
	If_torn_0() {strcpy(name,"IF_TORN_0");argnum=1;varnum=0;weight=100;
	evalfunc=If_torn_0Eval;};
	};

OPDEF(If_torn_1Eval)
{ 
			retval rval=0;
			move2=0;
			if (expressio==1) h++;
			if ((move1==1) || (expressio==1))
			{   
			  if ((Mesh[n]==1) || (expressio==1))
			  {  
				 move2=1;
				 rval=EVAL;
			  }
			  else {  
				 IP++;
				 TRAVERSE();
				 IP--;			  	
			  }
			}
			else rval=-1;	 		 
			return rval;
}

	class If_torn_1 : public Function {
	public:
	If_torn_1() {strcpy(name,"IF_TORN_1");argnum=1;varnum=0;weight=100;
	evalfunc=If_torn_1Eval;};
	};

OPDEF(If_torn_2Eval)
{ 
			retval rval=0;
			move2=0;
			if (expressio==1) h++;
			if ((move1==1) || (expressio==1))
			{   
			  if ((Mesh[n]==2) || (expressio==1))
			  {  
				 move2=1;
				 rval=EVAL;
			  }
			  else {  
				 IP++;
				 TRAVERSE();
				 IP--;			  	
			  }
			}
			else rval=-1;	 		 
			return rval;
}

	class If_torn_2 : public Function {
	public:
	If_torn_2() {strcpy(name,"IF_TORN_2");argnum=1;varnum=0;weight=100;
	evalfunc=If_torn_2Eval;};
	};

	
OPDEF(If_torn_3Eval)
{ 
			retval rval=0;
			move2=0;
			if (expressio==1) h++;
			if ((move1==1) || (expressio==1))
			{   
			  if ((Mesh[n]==3) || (expressio==1))
			  {  
				 move2=1;
				 rval=EVAL;
			  }
			  else {  
				 IP++;
				 TRAVERSE();
				 IP--;			  	
			  }
			}
			else rval=-1;	 		 
			return rval;
}

	class If_torn_3 : public Function {
	public:
	If_torn_3() {strcpy(name,"IF_TORN_3");argnum=1;varnum=0;weight=100;
	evalfunc=If_torn_3Eval;};
	};


	
OPDEF(If_torn_4Eval)
{ 
			retval rval=0;
			move2=0;
			if (expressio==1) h++;
			if ((move1==1) || (expressio==1))
			{   
			  if ((Mesh[n]==4) || (expressio==1))
			  {  
				 move2=1;
				 rval=EVAL;
			  }
			  else {  
				 IP++;
				 TRAVERSE();
				 IP--;			  	
			  }
			}
			else rval=-1;	 		 
			return rval;
}

	class If_torn_4 : public Function {
	public:
	If_torn_4() {strcpy(name,"IF_TORN_4");argnum=1;varnum=0;weight=100;
	evalfunc=If_torn_4Eval;};
	};
 
OPDEF(MoveMajor)
{
			retval rval=0;
			h++;
			if (expressio==0) 
			{ 
			  if (move2==1) 
			  {
				 if (test[n]==0) 
				 {
					Major();
					if (Proc[h1]==0)
					{
					  MovMajor();
					  rval=T;
					  Procedencia();
					}
				 } 
			  }		
			  else rval=-1;
			}
			else h++; 
			return rval;
}
		
		  
 
OPDEF(MoveMenor)
{
			retval rval=0;
			h++;
			if (expressio==0) 
			{ 
			  if (move2==1) 
			  {
				 if (test[n]==0) 
				 {
					Menor();
					if (Proc[h1]==0)
					{
					  MovMenor();
					  rval=T;
					  Procedencia();
					}
				 } 
			  } 		
			  else rval=-1;
			}
			else h++; 
			return rval;
}
		  
OPDEF(Res) 
{
			if (expressio==1) h++;
			return 0;
}  

OPDEF(Progn1)  {return (EVAL);}

OPDEF(Progn2)  {return ( EVAL + EVAL);}

OPDEF(Progn3)  {return ( EVAL + EVAL + EVAL);}

OPDEF(Progn4)  {return ( EVAL + EVAL + EVAL + EVAL);}

//**************************************************************************
///////////////////////// PROBLEM definition


GrilProb::GrilProb(ChromeParams* p) : Problem()
{
	AddF(new ConstFunc(0));                         // Required for GPQUICK, but zero weight

	// Problem specific functions
	AddF(new Function(1,0,100,IfProc_MajorEval,"IfProc_Major"));
	AddF(new Function(1,0,100,IfProc_MenorEval,"IfProc_Menor"));
	AddF(new Function(1,0,150,IfProc_OriEval,"IfProc_Ori"));
	
	AddF(new Function(1,0,100,If_torn_0Eval,"If_torn_0"));
	AddF(new Function(1,0,100,If_torn_1Eval,"If_torn_1"));
	AddF(new Function(1,0,100,If_torn_2Eval,"If_torn_2"));
	AddF(new Function(1,0,100,If_torn_3Eval,"If_torn_3"));
	AddF(new Function(1,0,100,If_torn_4Eval,"If_torn_4"));
	AddF(new Function(0,0,100,MoveMajor,"MoveMajor"));
	AddF(new Function(0,0,100,MoveMenor,"MoveMenor"));
 
	AddF(new Function(4,0,150,Progn4,"Prog4"));
	AddF(new Function(3,0,150,Progn3,"Prog3"));
	AddF(new Function(2,0,125,Progn2,"Prog2"));
	AddF(new Function(1,0,10,Progn1,"Prog1")); 

	AddF(new Function(0,0,75,Res,"Res"));

	// Set some parameters
	p->params[pRepeatEval]=0;                   // no need to repeat, same case each time
	p->params[pMuteConstWt]=0;                      // no constants
	 // Get to Koza type parameters
	p->params[pMuteWt]=15;                              // less mutation
	p->params[pAnnealMuteWt]=15;                    // disable annealing
	p->params[pAnnealCrossWt] =0;
	p->params[pInitExpr] =20;
	p->params[pMaxExpr] =70;
	// If you need to load problem specific data for evaluation
	// Or load an environment (a map, a scenario)
	// Do it here
 
}

float GrilProb::fitness(Chrome* chrome)
{

	int i,j,s;
	for (i=0;i<ORDRE;i++)
	{
	  Proc[i]=0; Mesh[i]=0;Paso[i]=0;Orden[i]=0;test[i]=0;Proced[i]=0;
	  utilitzat[i]=0;position[i]=0; 
	}
	float f=0;h=0;
	h1=0;n=0;
	ord=1;sup=0;major=0;pas=1;
	retval answer=0;
	retval s1=0;
	// mecanisme descombrat de la xarxa		  
			 for (s=0;s<W;s++)
			 {
				for (i=0;i<ORDRE;i++)
				{
				  n=position[i];
				  if ( (i==0) || ((Proc[n] != 0) && (Mesh[n]<5)&& (Paso[n]<pas)
							&& (test[n]==0)))
				  {
					 move2=0;move1=0;              // evalua la expressi
					 answer+= chrome->evalAll();   // sencera
					 f=answer;
					 h=0;
					 n=0;
					 expressio=1;          // evalua la seva longitud per
					 s1+= chrome->evalAll();     // minimitzarla
					 expressio=0;
					 f=f-(h*2);         // li resta a la fitness
					 chrome->nfitness->fvalue=f;						 
				  }
				}
				if (ord<=ORDRE-1)
				{
				  pas++;
				  Resetest();
				}
			 }		
	return f;
}

//**************************************************************************
///////////////////////////////  MAIN

//int main(int, char **)
int EvolveAnt()
// Run with a population of size 2000
// Run for 80,000 evals, or until it finds the answer
// DOS version will exit on keyboard hit
// Every 5 seconds or 1000 evals, print the best answer so far
{
	ChromeParams* params = new ChromeParams();
	Problem* prob=new GrilProb(params);
	Pop* pop;

	cout << "\nGPQUICK Artificial Hipercub graf Problem\n";

	srand(1);
	pop = new Pop(prob,params,TPB);                // population of size 2000
	a1=0;b1=0;
	int i,j,c1,xx;
	long double a2;

	make_nodes();
	make_arcs();

	int posicion,a3,a6;
	ofstream fin("HCUB_G.TXT",ios::out | ios::app);
	fin<<"\n";
	for (i=0;i<80;i++) fin<<'=';
	fin<<"\nHipercub no dirigit "<<" en "<<W<<" pasos";
	fin<<"\nNombre de Poblaci "<<TPB<<"\n";

	// Do for 80,000 iterations, or until we find the right answer
	while (pop->gencount<89000l)  // Portable version - not interruptible
	//while (pop->gencount<89000l && !kbhit())  // kbhit IS NOT PORTABLE (Borland specific)
	{   
		// go for 5 seconds, 1000 evals, or until we get a right answer
	  pop->go_until(time(NULL)+5,1000);
				
		// Display the best so far
	  cout << "\n\nAfter " << pop->gencount << " generates, #fitness found = " << pop->BestFitness->fvalue << "\n";
	  pop->pop[pop->BestMember]->write(PRETTY_NONE,cout);
	  cout.flush();
	  a1++;
	  fin<< "\nFitness="<<pop->BestFitness->fvalue;
	  fin<< " After "<<pop->gencount<<" generates";
	  fin<< "  Mitja "<<Vec_mitja[a1];
	}
	
	 // Pinta la grfica
	a6=b1;
	for(i=0;i<20;i++) graf[i][0]='|';
	for(i=0;i<b1;i++)	graf[20][i]='^';
	fin<<"\n";
		
	for(i=0;i<20;i++)
	  for(j=1;j<b1;j++) graf[i][j]=' ';	
	while (b1!=0)
	{
	  a2=Vec_fitness[b1];
	  a3=Posicio(&a2);
	  graf[20-a3][b1]='*';
	  a2=Vec_mitja[b1];
	  a3=Posicio(&a2);
	  graf[20-a3][b1]='#';
	  b1--;
	} 	  			
	for(i=0;i<21;i++)             
	{
	  fin<<"\n";
	  for(j=0;j<a6;j++) fin<<graf[i][j];	
	}
	
	// Display the best

	ofstream of("HCUB_R.TXT",ios::out | ios::app);
	cout << "\n\nFINAL RESULTS...";
	of<<"\n\nHipercub no dirigit en "<<W<<" pasos, T="<<T<<" i TPB="<<TPB;
	cout << "\nAfter " << pop->gencount << " generates, #fitness found = " << pop->BestFitness->fvalue << "\n";
	pop->pop[pop->BestMember]->write(PRETTY_NONE,cout);
	cout.flush();
	cout<<"****";pop->pop[pop->BestMember]->SetupEval();
	int y,z,s,k;
	float f=0;
		
		 // Get the track of the best ant
			
	n=0;h=0;h1=0;major=0;
	ord=1;pas=1;expressio=0;sup=0;
	for (i=0;i<ORDRE;i++)
	{	
	  Proc[i]=0;Mesh[i]=0;Paso[i]=0;Orden[i]=0;test[i]=0;Proced[i]=0;
	  position[i]=0;utilitzat[i]=0;
	}										  
	retval answer=0;
		  
			 for (s=0;s<W;s++)
			 {
				for (i=0;i<ORDRE;i++) 
				{
				  n=position[i];
				  if ( (i==0) || ((Proc[n] != 0) && (Mesh[n]<6)&& (Paso[n]<pas)
						  && (test[n]==0)))
				  {								  // evalua la millor expressi
					 move2=0;h=0;move1=0; 
					 answer+= pop->pop[pop->BestMember]->evalAll();
					 f=answer;
				  }
				}									
				if (ord<=ORDRE-1)
				{
				  pas++;
				  Resetest();
				}
			 }
	f=answer;	 
	
		 // Show the track
	cout << "\n";
	of << "\n";
	fin<<"\n";
			
	for (i=0;i<ORDRE;i++)
	{  
	  of<<"\n";
	  fin<<"\n";
	  cout<<"\n";
	  y=position[i];
	  for (j=LONGMOT-1;j>=0;j--)
	  {
		 c1=  vert[y].name[j];
		 of<< c1;
		 fin<<c1;
		 cout<<c1;	
	  }  
	  of<<"\t";
	  fin<<"\t";
	  cout<<"\t";
	  cout<<Proc[y]<< "\t"<<  Orden[y] << "\t" << Paso[y] <<"\t"<<Proced[y]<<"\t ";
	  fin<<Proc[y] << "\t"<< Orden[y] << "\t" << Paso[y] <<"\t"<<Proced[y]<<"\t ";
	  of<<Proc[y] << "\t"<< Orden[y] << "\t" << Paso[y] <<"\t"<<Proced[y]<<"\t ";
	}
				 
	cout<<"\nFitness="<<f << "After " << pop->gencount << " generates";		
	of<<"\nFitness="<<f << " After " << pop->gencount<< " generates";
	fin<<"\nFitness="<<f << " After "<<pop->gencount<<" generates";
	cout<<"\n";pop->pop[pop->BestMember]->write(PRETTY_NONE,cout);
	of<<"\n";pop->pop[pop->BestMember]->write(PRETTY_NONE,of);
	fin<<"\n";pop->pop[pop->BestMember]->write(PRETTY_NONE,fin);

	fin.close();                 	
	of.close();	 
	
	delete pop;
	delete prob;
	delete params;
	return 0;
}

int main(int, char **)
{
	EvolveAnt();
	return 0;
}
  
