//   Per evolucionar a partir de zero
//   evolucio = 1    i  en el fitxer CHROME.CPP
//			#define grafica 1/0  segons si es vol la grfica o no
//       #define mesh   0
//       #define toro   0
//       #define btfd   0
//       #define btfnd  0
//       #define ccc    0
//
//   Per introduir la expressio trobada
//   evolucio = 0     i en el fitxer CHROME:CPP
//			#define grafica 1/0 segons es vulgui trobar la grfica
//       #define mesh   1                                  o no
//       #define toro   0
//       #define btfd   0
//       #define btfnd  0
//       #define ccc    0

//   amb T 280 mesh de 5x5 troba la expressi bona bastant rpid

//**************************************************************************
//  GGGmesh.CPP trevalla el problema sobre un Mesh simple
//  noms es permeten dos moviments per node
//  horitzontal (cap a la dreta) y vertical (cap a baix)
//  no t incloses la construcci de la grfica de les fitness ni la de 
//  la evoluci de la transmissi
//**************************************************************************

#include "pch.h"
#include "chrome.h"
#include "primitiv.h"

extern char scratch[100];
#ifdef FASTEVAL
	extern evalnode* IpGlobal;
	extern Chrome* ChromeGlobal;
#endif

//**************************************************************************
// Define your Problem class

class GrilProb : public Problem {
public:
	GrilProb(ChromeParams* p);               // initialize functions, parameters, and data
	float fitness(Chrome* chrome);  // Driving ingredient - GP fitness function
};

//**************************************************************************
// static variables that make up the evaluation environment
// Build your environment here as statics
// where the evaluation functions can get to the data

#define Horizontal 5
#define Vertical 5             // tamany del Mesh
#define W  8                   // nombre de pases
#define T 280                   // increment positiu de la fitness
#define TPB 500                // tamany total de poblaci

int test[Horizontal][Vertical]; // prohibeix al node tornar a transmetre en un mateix pas
int Orden[Horizontal][Vertical];// pas de la seqncia de lalgoritme
int Paso[Horizontal][Vertical]; // etapa de pas de linformaci
int Mesh[Horizontal][Vertical]; // paquets transmesos pel node
int Proc[Horizontal][Vertical]; // procedncia del paquet rebut
long double Vec_fitness[400];    // guarda els valors de la fitness
long double Vec_mitja[400];      // guarda els valors de la fitness mitja de la poblaci
unsigned char graf[21][400];
unsigned char M_evol[Horizontal][Vertical];
int M_evol2[Horizontal][Vertical]; 
int pas,ord,b1,move2,move1,a1,a5;              // variables 
int expressio=0;                // habilita levaluacio del tamany de lexpressio
int xx=0;                       // position of the node
int yy=0;
int h=0;                        // comptador del tamany de lexpressio
int evolucio=1;                 // (Meshdirig=1 en chrome.cpp per generar a partir 
										  // duna expressi introduida

typedef struct positions{       // per guardar les posicions dels nodes per
	 int x;                      // anar escombrant la matriu duna forma no
	 int y;                      // predeterminada
	 } ;

positions position[Horizontal*Vertical];	 // vector que guarda aquestes posicions
//**************************************************************************
// Data handling functions

int Posicio(long double *ma)     // mitjanant una regla de tres col.loca els punts 
{                 // dintre de l`espai de valors de la grfica
	int posicio;
	posicio=(*ma*21)/((Horizontal*Vertical-1)*T);
	return posicio;
}

retval ProcHoriz()   // evalua la procedencia del paquet rebut
{ 
	retval rval=0;                       // si es un '1' indica procedncia
	rval= (Proc[xx][yy] == 1);    // horitzontal
	return rval;
}

retval ProcVert()   // evalua la procedencia del paquet rebut
{ 
	retval rval=0;                       // si s un '2' indica procedncia
	rval= (Proc[xx][yy] == 2);    // vertical
	return rval;
}
	
void Resetest()    // posa a zero la matriu 'test' per poder realitzar
{                  // un altre pas
	int i,j;
	for (j=0;j<Vertical;j++)
	{
	  for (i=0;i<Horizontal;i++) test[j][i]=0;
	}
}							

void MouteV()
{
	Mesh[xx][yy]++;            // incrementa el comptador 
	if (xx==Horizontal-1) Mesh[xx][yy]=2;
	Proc[xx][yy+1]=2;          // marca la procedencia
	Paso[xx][yy+1]=pas;        // guarda el pas en que rep el paquet
	test[xx][yy]=1;            // prohibeix al node transmisor 
	position[ord].x=xx;
	position[ord].y=yy+1;
	Orden[xx][yy+1]=ord;ord++; // guarda l`ordre sequencial en que
}	                           // rep la informaci

void MouteH()          // anlogament a lanterior
{
	Mesh[xx][yy]++;		
	if (yy==Vertical-1) Mesh[xx][yy]=2; // accelera el procs de 	
	Proc[xx+1][yy]=1;                   // recerca de nodes amb posibilitat
	Paso[xx+1][yy]=pas;                 // de transmetre
	test[xx][yy]=1;
	position[ord].x=xx+1;
	position[ord].y=yy;
	Orden[xx+1][yy]=ord;ord++;
}				 
			 
void MovimentH()       // incrementa el nombre de moviments dun node quan aquest
{			              // encara que pot transmetre no te cap vei que no hagi rebut
	if (Proc[xx][yy+1] != 0) Mesh[xx][yy]=2;
	if ((xx==Horizontal-1) && (yy==Vertical-1)) Mesh[xx][yy]=2;
	if ((yy==Vertical-1) && (Proc[xx+1][yy]!=0)) Mesh[xx][yy]=2;
}			  


void MovimentV()        // el mateix per per un node que transmet verticalment
{
	if (Proc[xx+1][yy]!=0)Mesh[xx][yy]=2; // mira el seguent horitzontal
	if ((xx==Horizontal-1)&&(yy==Vertical-1)) Mesh[xx][yy]=2; // si sest
								// a lextrem inferior dreta
	if ((xx==Horizontal-1) && (Proc[xx][yy+1]!=0))Mesh[xx][yy]=2; // si
}                       // sest a un extrem
			  
//**************************************************************************
//////////////////////////  Problem specific functions

// Use the OPDEF,EVAL,IP and CURCHROME defines
// and the code will recompile for different eval methods
	  
OPDEF(IfProc_OriEval)
{ 
			retval rval=0;
			move1=0; move2=0;
			if (expressio==1) h++; // comptador de longitud de la expressio
			if (((xx==0)&&(yy==0)) || (expressio==1))
			{
			  Proc[0][0]=4;  // marca com un quatre lorigen
			  move1=1;       // fora a mirar la procedncia abans de moures
			  rval=EVAL;
			}
			else {  
			  IP++;
			  TRAVERSE();    // salta dos expressions
			  IP--;   		  // Back up for EVAL
			}	
			return rval;
}

	class IfProc_Ori : public Function {
	public:
	IfProc_Ori() {strcpy(name,"IFPROC_ORI");argnum=1;varnum=0;weight=100;
	evalfunc=IfProc_OriEval;};
	};

OPDEF(IfProc_HEval)
{    
			retval rval=0;
			move1=0; move2=0;
			if (expressio==1) h++;
			if ((ProcHoriz()) || (expressio==1))
			{
			  move1=1;
			  rval=EVAL;				  
			}
			else {  
			  IP++;
			  TRAVERSE();
			  IP--;																		// Back up for EVAL				  
			}
			return rval;
}

	class IfProc_H : public Function {
	public:
	IfProc_H() {strcpy(name,"IFPROC_H");argnum=1;varnum=0;weight=100;
	evalfunc=IfProc_HEval;};
	};
						
	  
OPDEF(IfProc_VEval)
{ 
			retval rval=0;
			move1=0;move2=0;
			if (expressio==1) h++;
			if ((ProcVert()) || (expressio==1))
			{  
			  move1=1;
			  rval=EVAL;
			}
			else {  
			  IP++;
			  TRAVERSE();
			  IP--;			  	
			}		 
			return rval;
}

	class IfProc_V : public Function {
	public:
	IfProc_V() {strcpy(name,"IFPROC_V");argnum=1;varnum=0;weight=100;
	evalfunc=IfProc_VEval;};
	};

OPDEF(If_torn_0Eval)
{ 
			retval rval=0;
			move2=0;
			if (expressio==1) h++;
			if ((move1==1) || (expressio==1))
			{   
			  if ((Mesh[xx][yy]==0) || (expressio==1))
			  {  
				 move2=1;
				 rval=EVAL;
			  }
			  else {  
				 IP++;
				 TRAVERSE();
				 IP--;			  	
			  }
			}
			else rval=-1;	 		 
			return rval;
}

	class If_torn_0 : public Function {
	public:
	If_torn_0() {strcpy(name,"IF_TORN_0");argnum=1;varnum=0;weight=100;
	evalfunc=If_torn_0Eval;};
	};

OPDEF(If_torn_1Eval)
{ 
			retval rval=0;
			move2=0;
			if (expressio==1) h++;
			if ((move1==1) || (expressio==1))
			{  
			  if ((Mesh[xx][yy]==1) || (expressio==1))
			  { 
				 move2=1;
				 rval=EVAL;
			  }
			  else {  
				 IP++;
				 TRAVERSE();
				 IP--;			  	
			  }	
			}	 
			else rval=-1;	 	 
			return rval;
}

	class If_torn_1 : public Function {
	public:
	If_torn_1() {strcpy(name,"IF_TORN_1");argnum=1;varnum=0;weight=100;
	evalfunc=If_torn_1Eval;};
	};


OPDEF(MoveHoriz)  // si es pot moure per primer cop es mou horitzontal
{
			retval rval=0;
			if (expressio==0) 
			{ 
			  if (move2==1)
			  {  
				 if  ((xx<Horizontal-1) && (test[xx][yy]==0))
				 { 			
					if  (Proc[xx+1][yy]==0) // mira si es pot moure horitzontalment
					{
					  MouteH();// realitza el moviment 
					  rval=T;  // increment de la fitness al transmetre informaci
					}                       // a un node
					MovimentH();			
				 }
			  } 
			  else rval=-1; // penalitza si no ha mirat abans la procedncia
			}
			else h++;       // incrementa el comptador de la expressi
			return rval;
}	 	
	
OPDEF(MoveVert)
{  
			retval rval=0;
			if (expressio==0) 
			{
			  if (move2==1)
			  { 
				 if  ((yy<Vertical-1) && (test[xx][yy]==0))
				 {  
					if (Proc[xx][yy+1]==0)
					{		
					  MouteV();
					  rval=T;
					}
					MovimentV();
				 }
			  }	
			  else rval=-1; 
			}
			else h++; 
			return rval;
}
		  
OPDEF(Res) 
{
			if (expressio==1) h++;
			return 0;
}  


OPDEF(Progn1)  {return (EVAL);}

OPDEF(Progn2)  {return ( EVAL + EVAL);}

OPDEF(Progn3)  {return ( EVAL + EVAL + EVAL);}

OPDEF(Progn4)  {return ( EVAL + EVAL + EVAL + EVAL);}

//**************************************************************************
///////////////////////// PROBLEM definition


GrilProb::GrilProb(ChromeParams* p) : Problem()
{
	AddF(new ConstFunc(0));                         // Required for GPQUICK, but zero weight

	// Problem specific functions
	AddF(new Function(1,0,100,IfProc_HEval,"IfProc_H"));
	AddF(new Function(1,0,100,IfProc_VEval,"IfProc_V"));
	AddF(new Function(1,0,150,IfProc_OriEval,"IfProc_Ori"));
	
	AddF(new Function(1,0,100,If_torn_0Eval,"If_torn_0"));
	AddF(new Function(1,0,100,If_torn_1Eval,"If_torn_1"));
	AddF(new Function(0,0,100,MoveHoriz,"MoveHoriz"));
	AddF(new Function(0,0,100,MoveVert,"MoveVert"));
 
	AddF(new Function(4,0,150,Progn4,"Prog4"));
	AddF(new Function(3,0,150,Progn3,"Prog3"));
	AddF(new Function(2,0,125,Progn2,"Prog2"));
	AddF(new Function(1,0,10,Progn1,"Prog1")); 

	AddF(new Function(0,0,75,Res,"Res"));

	// Set some parameters
	p->params[pRepeatEval]=0;                   // no need to repeat, same case each time
	p->params[pMuteConstWt]=0;                  // no constants
	// Get to Koza type parameters
	p->params[pMuteWt]=15;                      // less mutation
	p->params[pAnnealMuteWt]=15;                // disable annealing
	p->params[pAnnealCrossWt] =0;
	p->params[pInitExpr] =10;
	p->params[pMaxExpr] =50;
	// If you need to load problem specific data for evaluation
	// Or load an environment (a map, a scenario)
	// Do it here
 
}

float GrilProb::fitness(Chrome* chrome)
{
	xx=0;
	yy=0;
	int i,j,s;
	float f=0;h=0;
	for (i=0;i<Vertical;i++)
	  for (j=0;j<Horizontal;j++)
	  {
		 Proc[j][i]=0; Mesh[j][i]=0;Paso[j][i]=0;Orden[j][i]=0;test[j][i]=0;
	  }				  
	for (i=0;i<Horizontal*Vertical;i++)
	{
	  position[i].x=0;
	  position[i].y=0;
	}            

	ord=1;pas=1;
	retval answer=0;
	retval s1=0;
	// mecanisme descombrat de la xarxa	  
			 for (s=0;s<W;s++)    // bucle pel n de pasos
			 {
				for (i=0;i<Horizontal*Vertical;i++)	
				{
				  xx=position[i].x;
				  yy=position[i].y;
				  if ( (i==0) || ((Proc[xx][yy] != 0) && (Mesh[xx][yy]<2)
							  && (Paso[xx][yy]<pas) && (test[xx][yy]==0)))
				  {
					 move2=0;           // evalua la expressi
					 move1=0;
					 answer+= chrome->evalAll();   // sencera
					 f=answer;
					 h=0; 
					 xx=0;yy=0;
					 expressio=1;       // evalua la seva longitud per
					 s1+= chrome->evalAll();     // minimitzarla
					 expressio=0;
					 f=f-(h*2);         // li resta a la fitness
					 chrome->nfitness->fvalue=f;						 
				  }
				}				
				if (ord<=(Horizontal*Vertical)-1)
				{
				  pas++;      // augmenta el comptador de pasos
				  Resetest(); // habilita els nodes que han trasms informaci
				}              // per tornar a transmetre
			 }		
			 return f;
}

//**************************************************************************
///////////////////////////////  MAIN

//int main(int, char **)
int EvolveAnt()
// Run with a population of size 2000
// Run for 80,000 evals, or until it finds the answer
// DOS version will exit on keyboard hit
// Every 5 seconds or 1000 evals, print the best answer so far

{

	ChromeParams* params = new ChromeParams();
	Problem* prob=new GrilProb(params);
	Pop* pop;
	cout << "\nGPQUICK Artificial Mesh Problem\n";
	srand(1);  // en lloc de rndomize(); que dona error a lhora de compilar
	pop = new Pop(prob,params,TPB);   // population of size TPB

	int i,j,a3,a6;
	long double a2;

	ofstream fin("MESH5x5_G.TXT",ios::out | ios::app);
	fin<<"\n";
	for (i=0;i<80;i++) fin<<'=';
	fin<<"\nMesh ->"<<Horizontal<<"x"<<Vertical<<" en "<<W<<" pasos";
	fin<<"\nNombre de Poblaci "<<TPB<<"\n";

	// Do for 80,000 iterations, or until we find the right answer
	//while (pop->gencount<39000l && !done)  // Portable version - not interruptible
	//while (pop->gencount<89000l && !kbhit())  // kbhit IS NOT PORTABLE (Borland specific)
	while (pop->gencount<22000l)
       {   
		// go for 5 seconds, 1000 evals, or until we get a right answer
		pop->go_until(time(NULL)+5,1000);
				
		// Display the best so far
		cout << "\n\nAfter " << pop->gencount << " generates, #fitness found = " << pop->BestFitness->fvalue << "\n";
		pop->pop[pop->BestMember]->write(PRETTY_NONE,cout);
		cout.flush();	
	}

		 // Pinta la grfica
	a6=b1;
	for(i=0;i<20;i++) graf[i][0]='|';
	for(i=0;i<b1;i++)	graf[20][i]='^';
	fin<<"\n";		
	for(i=0;i<20;i++)
	  for(j=1;j<b1;j++) graf[i][j]=' ';	
	while (b1!=0)
	{
	  a2=Vec_fitness[b1];
	  a3=Posicio(&a2);
	  graf[20-a3][b1]='*';
	  a2=Vec_mitja[b1];
	  a3=Posicio(&a2);
	  graf[20-a3][b1]='#';
	  b1--;
	} 	  			
	for(i=0;i<21;i++)             
	{
	  fin<<"\n";
	  for(j=0;j<a6;j++) fin<<graf[i][j];	
	}

	// Display the best

	ofstream of("M5x5_R.TXT",ios::out | ios::app);
	cout << "\n\nFINAL RESULTS...";
	of<<"\n\nMesh dirigit de "<<Horizontal<<"x"<<Vertical<<" en "<<W<<" pasos amb TPB= "<<TPB;
	cout << "\nAfter " << pop->gencount << " generates, #fitness found = " << pop->BestFitness->fvalue << "\n";
	pop->pop[pop->BestMember]->write(PRETTY_NONE,cout);
	cout.flush();
	cout<<"****";pop->pop[pop->BestMember]->SetupEval();
	int s,x,y,k;
	float f=0;
		
		 // Get the track of the best 
			
	xx=0; yy=0;h=0;
	ord=1;pas=1;expressio=0;
	for (i=0;i<Vertical;i++)
	  for (j=0;j<Horizontal;j++)
	  {
		 Proc[j][i]=0;Mesh[j][i]=0;Paso[j][i]=0;Orden[j][i]=0;test[j][i]=0;
	  }										  
	for (i=0;i<Horizontal*Vertical;i++)
	{
	  position[i].x=0;
	  position[i].y=0;
	}            
	retval answer=0; 	  

			 for (s=0;s<W;s++)
			 {
				for (i=0;i<Horizontal*Vertical;i++) 
				{
				  xx=position[i].x;
				  yy=position[i].y;
				  if ( (i==0) || ((Proc[xx][yy] != 0) && (Mesh[xx][yy]<2)
							&& (Paso[xx][yy]<pas) && (test[xx][yy]==0)))
				  {								  // evalua la millor expressi
					 move2=0;h=0;move1=0; 
					 answer+= pop->pop[pop->BestMember]->evalAll();
					 f=answer;
				  }
				}				  
				if (ord<=(Horizontal*Vertical)-1)
				{
				  pas++;
				  Resetest();
				}
			 }
			 f=answer;   	
		 // Mostra la transmisi en el fitxer MESH_R.TXT-> Procedencia
												  //  -> Ordre i
	cout << "\n";                            //  -> Pas
	of << "\n";                              // en 3 columnes
	for (y=0; y<Vertical; y++)
	{
	  for (x=0; x<Horizontal; x++)
	  {
		 cout<<Proc[x][y]<< "\t"<< Paso[x][y] <<"\t ";
			of<<Proc[x][y]<< "\t"<< Paso[x][y] <<"\t ";
	  }
	  cout<<"\n";
	  of<<"\n";
	}  
					
	cout<<"\nFitness="<<f << "After " << pop->gencount << " generates";		
	  of<<"\nFitness="<<f << " After " << pop->gencount<< " generates";
	cout<<"\n";pop->pop[pop->BestMember]->write(PRETTY_NONE,cout);
	  of<<"\n";pop->pop[pop->BestMember]->write(PRETTY_NONE,of);

	cout << "\nResult in RESULT:TXT";

		 // Pinta l`evoluci en la transmisi
	ofstream fa1("M5x5_E.TXT",ios::out | ios::app);
	fa1<<"\n FITXER DEVOLUCIO DE LA TRANSMISIO";
	for(i=0;i<Horizontal;i++)
	  for(j=0;j<Vertical;j++) M_evol[i][j]=' ';	
	for(i=0;i<=W;i++)
	{
	  for(j=0;j<Horizontal;j++)
		 for(k=0;k<Vertical;k++)
			if (Paso[j][k]==i)
			{
			  M_evol[j][k]='*';
			  M_evol2[j][k]=i;
			}
	  fa1<<"\n paso  "<<i<<hex;
	  for(k=0;k<Vertical;k++)
	  {
		 fa1<<"\n"<<"\t";
		 for(j=0;j<Horizontal;j++)
		 {
			if (M_evol2[j][k]!='') fa1<<M_evol2[j][k]<<hex;				
			else fa1<<M_evol[j][k];
		 }
	  }
	  fa1<<"\n"<<"\t";
	  for(j=0;j<Horizontal;j++) fa1<<'^';	 
	  for(j=0;j<Horizontal;j++)
		 for(int k=0;k<Vertical;k++)
			if (M_evol[j][k]=='*')
			{
			  M_evol[j][k]='';
			  M_evol2[j][k]='';
			}
	}
	fa1.close();
	of.close();	 
	fin.close();
	
	delete pop;
	delete prob;
	delete params;
	return 0;
}

int main(int, char **)
{
	EvolveAnt();
	return 0;
}
  
